<?php
class Nuts_MongoUser
{
	function get_basic_user($user)
	{
		$select = array( "_id" => 1
					, "name" => 1
					, "dname" => 1
					, "email" => 1
					//, "pass" => 0
					, 'stamp' => 1
					);
		return DB::$db->users->findOne(array("_id" => $user), $select);
	}
	
		

	function get_user($user)
	{
		return DB::$db->users->findOne(array("_id" => $user));
	}
	
		

	
	protected function mail_visibility($visibility, $user)
	{
		return DB::$db->users->update(array('_id' =>  $user), array('$set' => array("visiblemail" => $visibility)));
	}

	function set_data_profile($user, $data)
	{
		return DB::$db->users->update(array('_id' =>  $user), array('$set' => array("data" => $data)));
	}

	protected function register($user, $email, $pass)
	{
		$obj = array( "_id" => $user
					, "name" => $user
					, "dname" => $user
					, "email" => $email
					, "pass" => $pass
					, 'stamp' => new MongoDate() 
					);
		DB::$db->users->insert($obj);
		Nuts_MongoUser::add_update($user, 'register' , '' );
		Nuts_User::send_message('ereselchef', $user, "Bienvenido a eres el chef $user");
		return $obj;
	}
	
	protected function delete_user($user)
	{
		return DB::$db->users->remove(array('_id' =>  $user));
	}
	
	
	protected function get_recipes_for($user)
	{
		return iterator_to_array(DB::$db->recipes->find(array("user._id" => $user)));
	}
	protected function get_recipe_counter($user)
	{
		return DB::$db->recipes->find(array("user._id" => $user))->count();
	}
	
	protected function get_alternative_counter($user)
	{	
		return "TO DO";
		return DB::$db->recipes->find(array('comments.user' => 'weapp'))->count();
	}

	protected function get_favorited_counter($user)
	{
		return "TODO";

		$r = DB::$db->recipes->group( array("user" => 1)
								, array("csum" => 0)
								, new MongoCode("function(obj, prev){prev.csum += obj.nfavs;}")
								, array("condition" => array("user" => $user)) 
								);
		return $r['retval'][0]['csum'];
	}
	
	function is_follow($following, $followed){
		return (bool)(DB::$db->users->findOne(array("_id" => $following, "following._id"=> $followed)));
	}
	
	
	function add_update(&$user, $type, $obj){
		$o = array('user' => DB::$db->users->findOne(array('_id' =>  $user))
								, 'type' => $type
								, 'stamp' => new MongoDate()
								, 'update' =>$obj);
		//dump($o);
		return DB::$db->updates->insert($o);

	}
	
	function remove_update($user, $id){
		dump ( $user, "$id");
		$r = DB::$db->updates->remove(array('_id' => new MongoId($id), 'user.name'=>$user));
	}
	
	function add_follow($following, $followed){
		$o_following = Nuts_MongoUser::get_basic_user($following);
		$o_followed = Nuts_MongoUser::get_basic_user($followed);
		
		$obj = array(
				'user' => $o_followed
		);
		Nuts_MongoUser::add_update($following, 'following', &$o_followed);
		
		Nuts_MongoUser::add_notification($o_followed,'following', &$o_following);
		
		DB::$db->users->update( array('_id' =>  $following), array('$push' => array('following' => $o_followed)));
		DB::$db->users->update( array('_id' =>  $followed), array('$push' => array('followed' => $o_following) ));
		return 1;
	}
	function delete_follow($following, $followed){
		DB::$db->users->update( array('_id' =>  $following),
							array('$pull' => array('following' => array('_id' =>  $followed)))
						);
		DB::$db->users->update( array('_id' =>  $followed),
							array('$pull' => array('followed' => array('_id' =>  $following)))
						);
	}

	
	
	public function get_follow_updates($user, $aux_cond=array())
	{
		$cond = array('name' => $user);
		$f = &DB::$db->users->findOne($cond, array('following._id'=>1));
		$f['following'][]=$f;
		$f = $f['following'];
		$b = array();
		foreach ($f as $i) $b[] = $i['_id'];
		$cond_ = array('user._id' => array('$in'=>$b));
		$cond = array_merge($cond_, $aux_cond);
		$u = &DB::$db->updates->find( $cond, array('user.name'=>1, 'type'=>1, 'stamp'=>1,'update'=>1,'comments.user.name'=>1,'comments.text'=>1,'comments.stamp'=>1) )->sort(array('stamp'=>-1));
		$r = iterator_to_array($u);
		
		
		return $r;
	}
	
	public function get_updates($user, $page=null)
	{	
	
		$limit = Nuts_Recipe::$limit;
		$init=(($page?$page:1) - 1) * $limit;
		$cond = array("user.name"=>$user);
		return iterator_to_array(DB::$db->updates->find($cond)->sort(array('stamp'=>-1))->limit($limit)->skip($init));
	}
	
	
	public function count_updates($user)
	{	
		$cond = array("user.name"=>$user);
		return ceil(DB::$db->updates->find($cond)->count() / Nuts_Recipe::$limit);
	}
	
	public function get_update($user, $id)
	{
		$cond = array("user.name"=>$user);
		if($id){ $cond['_id'] = new MongoId($id);}
		return iterator_to_array(DB::$db->updates->find($cond)->sort(array('stamp'=>-1)));
	}
	
	public function get_messages($user, $id=null){
		$cond = array("users.name"=>$user);
		if($id)
		{
			$cond['_id'] = $id;
			DB::$db->threads->update($cond, array('$addToSet'=>array("read"=>$user)));
		}
		
		return iterator_to_array(DB::$db->threads->find($cond)->sort(array('stamp'=>-1)));
	}
	
	public function add_notification($user, $type, $notification, $url=null){
		$o_user = &DB::$db->users->findOne(array("_id" => $user), array('name'=>1));
		$o = array('user' => $user
			, 'notification' => &$notification
			, 'type' => $type
			, 'stamp' => new MongoDate()
			, 'read'  => 0
			);
		DB::$db->notifications->insert( &$o );
	}
	
	
	
	function get_notifications($user){
		$cond = array('read' => 0, 'user.name'=>$user);
		return iterator_to_array(DB::$db->notifications->find(&$cond)->sort(array('$natural'=>-1))->limit(10));
	}
	
	
	function read_notification($user, $id){
		$cond = array('_id' => new MongoId($id), 'user.name'=>$user);
		return DB::$db->notifications->update($cond, array('read'=>array('$set'=>1)));
	}
	
	
	function get_unread_notifications($user){
		$cond = array('read' => 0, 'user.name'=>$user);
		return DB::$db->notifications->find(&$cond)->count();
	}
	
	
	public function send_message($from, $to, $message, $id=null){
	

		$parser = new Nuts_Parser();
		$parser->parse($to, 'msg_to')
				->not_empty("Debe introducir un nombre de usuario")
				->exist('Nuts_MongoUser::get_basic_user', array($to), "El usuario no existe");
		$parser->parse($message, 'msg_text')
				->not_empty("El mensaje no puede estar vacío");
				
		if(Parse::is_error()) return;
	
		$o_from = &DB::$db->users->findOne(array("_id" => $from), array('name'=>1));
		$o_to = &DB::$db->users->findOne(array("_id" => $to), array('name'=>1));
		$obj = array( 'from' => $o_from
					, 'to' => $o_to
					, 'text' => $message
					, 'stamp' => new MongoDate()
					);
		
		if ($id){
			$cond = array( 'users.name' => array( '$all' => array($o_from['name'], $o_to['name']) )
						 , '_id' =>  $id
						 );
		
			$upda = array( '$push' => array('messages' => $obj)
						   , '$set' => array( 'stamp' => new MongoDate()
											, 'read' => array($from)
											)
						   );
			
			DB::$db->threads->update( &$cond, &$upda );
		}else{
			$o = array('_id' => $from<$to ? "$from:$to" : "$to:$from"
					  ,'users' => array($o_from, $o_to)
					  ,'stamp' => new MongoDate()
					  ,'read' => array($o_from['name'])
					  ,'messages' => array($obj)
					  );
			DB::$db->threads->insert( &$o );
			$id = $o['_id'];
		}

		Nuts_Nuts::redirect("?id=$id&to=$to");
	}
	
	function get_unread($user){
		$cond = array('read' => array('$ne' => $user), 'users.name'=>$user);
		return DB::$db->threads->find(&$cond)->count();
	}
	
	protected function add_comment_update($update, $user, $comment)
	{
		$o_user = Nuts_MongoUser::get_basic_user($user);
		$collection = DB::$db->updates;
		$obj = array(
				'type' => 'comment' ,
				'stamp' => new MongoDate() ,
				'user' => &$o_user,
				'text' => $comment
		);
		$cond = array('_id' =>  new MongoId($update));
		$o_update = $collection->findOne($cond);
		$upda = array('$push' => array( "comments" => $obj ), '$inc' => array("ncomments" => 1) );
		
		Nuts_MongoUser::add_notification($o_update['user'],'comment_update', array("user"=> &$o_user, "update"=>&$o_update));
		
		return $collection->update( &$cond, &$upda );
	}
	
	
}
?>